diff --git a/drivers/net/ethernet/8390/8390p.c b/drivers/net/ethernet/8390/8390p.c
index 6834742057b3..2305dbf74d79 100644
--- a/drivers/net/ethernet/8390/8390p.c
+++ b/drivers/net/ethernet/8390/8390p.c
@@ -1,14 +1,23 @@
 // SPDX-License-Identifier: GPL-2.0-only
-/* 8390 core for ISA devices needing bus delays */

-static const char version[] =
-    "8390p.c:v1.10cvs 9/23/94 Donald Becker (becker@cesdis.gsfc.nasa.gov)\n";
+#define DRV_DESCRIPTION "8390 core for ISA devices needing bus delays"
+#define DRV_AUTHOR "Donald Becker (becker@cesdis.gsfc.nasa.gov)"

 #define ei_inb(_p)	inb(_p)
 #define ei_outb(_v, _p)	outb(_v, _p)
 #define ei_inb_p(_p)	inb_p(_p)
 #define ei_outb_p(_v, _p) outb_p(_v, _p)

+#include <linux/etherdevice.h>
+#include <linux/export.h>
+#include <linux/init.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/netdevice.h>
+
+MODULE_AUTHOR(DRV_AUTHOR);
+MODULE_DESCRIPTION(DRV_DESCRIPTION);
+
 #include "lib8390.c"

 int eip_open(struct net_device *dev)
diff --git a/drivers/net/ethernet/8390/ax88796.c b/drivers/net/ethernet/8390/ax88796.c
index 172947fc051a..f2269c387d14 100644
--- a/drivers/net/ethernet/8390/ax88796.c
+++ b/drivers/net/ethernet/8390/ax88796.c
@@ -27,7 +27,6 @@

 #include <net/ax88796.h>

-
 /* Rename the lib8390.c functions to show that they are in this driver */
 #define __ei_open ax_ei_open
 #define __ei_close ax_ei_close
@@ -55,8 +54,6 @@
 /* Ensure we have our RCR base value */
 #define AX88796_PLATFORM

-static unsigned char version[] = "ax88796.c: Copyright 2005,2007 Simtec Electronics\n";
-
 #include "lib8390.c"

 #define DRV_NAME "ax88796"
diff --git a/drivers/net/ethernet/8390/etherh.c b/drivers/net/ethernet/8390/etherh.c
index bd22a534b1c0..c801cb13ba44 100644
--- a/drivers/net/ethernet/8390/etherh.c
+++ b/drivers/net/ethernet/8390/etherh.c
@@ -56,9 +56,6 @@
 #define DRV_NAME	"etherh"
 #define DRV_VERSION	"1.11"

-static char version[] =
-	"EtherH/EtherM Driver (c) 2002-2004 Russell King " DRV_VERSION "\n";
-
 #include "lib8390.c"

 struct etherh_priv {
diff --git a/drivers/net/ethernet/8390/hydra.c b/drivers/net/ethernet/8390/hydra.c
index 941754ea78ec..28b55ac578c9 100644
--- a/drivers/net/ethernet/8390/hydra.c
+++ b/drivers/net/ethernet/8390/hydra.c
@@ -36,11 +36,14 @@
 #define ei_inb_p(port)   in_8(port)
 #define ei_outb_p(val,port)  out_8(port,val)

-static const char version[] =
-    "8390.c:v1.10cvs 9/23/94 Donald Becker (becker@cesdis.gsfc.nasa.gov)\n";
+#define DRV_DESCRIPTION "New Hydra driver using generic 8390 core"
+#define DRV_AUTHOR "Peter De Schrijver (p2@mind.be)"

 #include "lib8390.c"

+MODULE_AUTHOR(DRV_AUTHOR);
+MODULE_DESCRIPTION(DRV_DESCRIPTION);
+
 #define NE_EN0_DCFG     (0x0e*2)

 #define NESM_START_PG   0x0    /* First page of TX buffer */
diff --git a/drivers/net/ethernet/8390/mac8390.c b/drivers/net/ethernet/8390/mac8390.c
index d60a86aa8aa8..1484497e4df5 100644
--- a/drivers/net/ethernet/8390/mac8390.c
+++ b/drivers/net/ethernet/8390/mac8390.c
@@ -41,9 +41,6 @@
 #include <asm/hwtest.h>
 #include <asm/macints.h>

-static char version[] =
-	"v0.4 2001-05-15 David Huggins-Daines <dhd@debian.org> and others\n";
-
 #define EI_SHIFT(x)	(ei_local->reg_offset[x])
 #define ei_inb(port)	in_8(port)
 #define ei_outb(val, port)	out_8(port, val)
diff --git a/drivers/net/ethernet/8390/mcf8390.c b/drivers/net/ethernet/8390/mcf8390.c
index 4ad8031ab669..7e30a7524cdd 100644
--- a/drivers/net/ethernet/8390/mcf8390.c
+++ b/drivers/net/ethernet/8390/mcf8390.c
@@ -20,9 +20,6 @@
 #include <linux/io.h>
 #include <asm/mcf8390.h>

-static const char version[] =
-	"mcf8390.c: (15-06-2012) Greg Ungerer <gerg@uclinux.org>";
-
 #define NE_CMD		0x00
 #define NE_DATAPORT	0x10	/* NatSemi-defined port window offset */
 #define NE_RESET	0x1f	/* Issue a read to reset ,a write to clear */
diff --git a/drivers/net/ethernet/8390/xsurf100.c b/drivers/net/ethernet/8390/xsurf100.c
index e2c963821ffe..6f1e3d539346 100644
--- a/drivers/net/ethernet/8390/xsurf100.c
+++ b/drivers/net/ethernet/8390/xsurf100.c
@@ -42,9 +42,6 @@
 /* Ensure we have our RCR base value */
 #define AX88796_PLATFORM

-static unsigned char version[] =
-		"ax88796.c: Copyright 2005,2007 Simtec Electronics\n";
-
 #include "lib8390.c"

 /* from ne.c */
diff --git a/drivers/net/ethernet/8390/zorro8390.c b/drivers/net/ethernet/8390/zorro8390.c
index 35a500a21521..75df604801cf 100644
--- a/drivers/net/ethernet/8390/zorro8390.c
+++ b/drivers/net/ethernet/8390/zorro8390.c
@@ -41,11 +41,12 @@
 #define ei_inb_p(port)		in_8(port)
 #define ei_outb_p(val, port)	out_8(port, val)

-static const char version[] =
-	"8390.c:v1.10cvs 9/23/94 Donald Becker (becker@cesdis.gsfc.nasa.gov)\n";
+#define DRV_DESCRIPTION "Amiga Linux/m68k and Linux/PPC Zorro NS8390 Ethernet Driver"

 #include "lib8390.c"

+MODULE_DESCRIPTION(DRV_DESCRIPTION);
+
 #define DRV_NAME	"zorro8390"

 #define NE_BASE		(dev->base_addr)